// File: Multimap.java
// Example of a map with multiple values for each key
// Lists all words in any file, storing the words by letter

import java.util.*;
import java.io.*;

public class Multimap {

    public static void main(String[] args) {

        // Read words from file and put into a simulated multimap
        Map<Character, ArrayList<String>> WordLists
	    = new TreeMap<Character, ArrayList<String>>();
        try {
	    Scanner s = new Scanner(new File(args[0]));
            while (s.hasNext()) {
		String word = s.next();
		char firstLet=Character.toUpperCase(word.charAt(0));
		if (firstLet>='A' && firstLet <= 'Z') {
		  ArrayList<String> AList=WordLists.get(firstLet);
		  if (AList==null) {
		    AList=new ArrayList();
		    // Add this...only need to put new key,value pairs
		    WordLists.put(firstLet,AList);
		  }
	          AList.add(word);
	          // don't need to; value ref is unchanged
                  // WordLists.put(firstLet,AList);  
                }  
            }
        } catch (IOException e) {
            System.err.println(e);
            System.exit(1);
        }

        // Print all lists
        // First, iterate over all values
        System.out.println("Just the lists....");
        for (List<String> l : WordLists.values())
          System.out.println(l);
        // Now, get the lists by key; note use of char in for loop and get
        System.out.println("\n**********Lists prefaced by their key**********");
        for (char c : WordLists.keySet())
          System.out.println(c + ": " + WordLists.get(c));
    }

}
